import {isAmazonProductPage, isCorrectTopCategory} from "./utils.js";

/*function getFromStorage(key) {
  return new Promise((resolve, reject) => {
    chrome.storage.local.get([key], (result) => {
      if (chrome.runtime.lastError) {
        reject(chrome.runtime.lastError);
      } else {
        resolve(result[key]);
      }
    });
  });
}

function setToStorage(key, value) {
  return new Promise((resolve, reject) => {
    chrome.storage.local.set({ [key]: value }, () => {
      if (chrome.runtime.lastError) {
        reject(chrome.runtime.lastError);
      } else {
        resolve();
      }
    });
  });
}*/
/*chrome.tabs.onUpdated.addListener((tabId, changeInfo, tab) => {

  // if changeInfo.status != complete return
  if (!('status' in changeInfo) || changeInfo.status !== "complete") return;

  if (tab.url) {

    if (isAmazonProductPage(tab.url)) {

    }


  }
});*/

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'CHECKTOPCATEGORY_BG') {

    console.log('bg.js, CHECKTOPCATEGORY_BG', message.tab.url, message.topCategoryURL, isCorrectTopCategory(message.tab.url, message.topCategoryURL));
    if (isCorrectTopCategory(message.tab.url, message.topCategoryURL) || 1 == 1){

      sendResponse(true);
    }
    else {
      sendResponse(false);
    }
  }
});

let monitoredTabId = null;

chrome.runtime.onMessage.addListener((message, sender, sendResponse) => {
  if (message.type === 'SET_TOKEN') {
    setAccessToken(message.payload)
        .then(() => {

        })
        .catch((error) => {
          console.error('Error saving token:', error);
        });
  }
});

chrome.tabs.onUpdated.addListener((tabId, changeInfo, tab) => {


  if (changeInfo.status === "complete" && tab.url === 'https://app.reviewmaticai.com/admin/extension_login?countries_group=1') {
    chrome.scripting.executeScript({
      target: { tabId: tab.id },
      files: ['login.js']
    });
  }
  else  {

  }
});


async function setAccessToken(token) {
  return new Promise((resolve, reject) => {
    const tokenData = {
      value: token,
      setAt: Date.now()
    };

    chrome.storage.local.set({ accessToken: tokenData }, () => {
      if (chrome.runtime.lastError) {
        reject(chrome.runtime.lastError);
      } else {
        resolve();
      }
    });
  });
}